'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _computer = require('./computer');

var _computer2 = _interopRequireDefault(_computer);

var _row = require('./row');

var _row2 = _interopRequireDefault(_row);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AnyHeight = function (_Component) {
    _inherits(AnyHeight, _Component);

    function AnyHeight(props) {
        _classCallCheck(this, AnyHeight);

        var _this = _possibleConstructorReturn(this, (AnyHeight.__proto__ || Object.getPrototypeOf(AnyHeight)).call(this, props));

        var length = props.length,
            minRowHeight = props.minRowHeight,
            height = props.height,
            preloadBatchSize = props.preloadBatchSize;


        _this.computer = new _computer2.default(minRowHeight, length, height);

        _this.state = Object.assign({
            isScrolling: false
        }, _this.computer.getDisplayData(0, preloadBatchSize, 0, 0));

        _this.handleScroll = _this.handleScroll.bind(_this);
        _this.updateRowHeight = _this.updateRowHeight.bind(_this);
        _this.manageScrollTimeOut = _this.manageScrollTimeOut.bind(_this);

        _this.lastScrollTop = 0;
        return _this;
    }

    _createClass(AnyHeight, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _state = this.state,
                beginIndex = _state.beginIndex,
                endIndex = _state.endIndex;

            this.computer.updateRowHeightAfterScroll(beginIndex, endIndex);
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.state.isScrolling) {
                var _state2 = this.state,
                    beginIndex = _state2.beginIndex,
                    endIndex = _state2.endIndex;

                this.ref.scrollTop = this.lastScrollTop;
                this.computer.updateRowHeightAfterScroll(beginIndex, endIndex);
            }
        }
    }, {
        key: 'handleScroll',
        value: function handleScroll(e) {
            var scrollTop = e.target.scrollTop;
            var _state3 = this.state,
                beginIndex = _state3.beginIndex,
                beforeHeight = _state3.beforeHeight;


            if (scrollTop === this.lastScrollTop) {
                return;
            }

            this.manageScrollTimeOut();

            this.setState(this.computer.getDisplayData(scrollTop, this.props.preloadBatchSize, beginIndex, beforeHeight));

            this.lastScrollTop = scrollTop;
        }
    }, {
        key: 'updateRowHeight',
        value: function updateRowHeight(index, height) {
            this.computer.cacheRowHeight(index, height);
        }
    }, {
        key: 'manageScrollTimeOut',
        value: function manageScrollTimeOut() {
            if (this.state.scrollTimeout) {
                clearTimeout(this.state.scrollTimeout);
            }

            var that = this;
            var scrollTimeout = setTimeout(function () {
                that.setState({
                    isScrolling: false,
                    scrollTimeout: undefined
                });
            }, this.props.timeScrollStateLastsForAfterUserScrolls);

            this.setState({
                isScrolling: true,
                scrollTimeout: scrollTimeout
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                minRowHeight = _props.minRowHeight,
                height = _props.height,
                style = _props.style,
                rowStyle = _props.rowStyle,
                rowRender = _props.rowRender;
            var _state4 = this.state,
                beginIndex = _state4.beginIndex,
                endIndex = _state4.endIndex,
                beforeHeight = _state4.beforeHeight,
                afterHeight = _state4.afterHeight;

            var wapperStyle = Object.assign({}, style, {
                height: height + 'px',
                overflowY: 'scroll'
            });

            var rowWapperStyle = Object.assign({}, rowStyle, {
                minHeight: minRowHeight + 'px'
            });

            var showData = [];
            for (var index = beginIndex; index <= endIndex; index += 1) {
                showData.push(_react2.default.createElement(
                    _row2.default,
                    {
                        key: index,
                        index: index,
                        updateRowHeight: this.updateRowHeight
                    },
                    rowRender(index, rowWapperStyle)
                ));
            }

            return (
                // eslint-disable-next-line no-return-assign
                _react2.default.createElement(
                    'div',
                    { style: wapperStyle, onScroll: this.handleScroll, ref: function ref(_ref) {
                            return _this2.ref = _ref;
                        } },
                    _react2.default.createElement('div', { style: { height: beforeHeight + 'px' } }),
                    showData,
                    _react2.default.createElement('div', { style: { height: afterHeight + 'px' } })
                )
            );
        }
    }]);

    return AnyHeight;
}(_react.Component);

exports.default = AnyHeight;


AnyHeight.defaultProps = {
    height: 300,
    preloadBatchSize: 5,
    style: {
        width: '100%'
    },
    rowStyle: {},
    minRowHeight: 32,
    timeScrollStateLastsForAfterUserScrolls: 150
};

AnyHeight.propTypes = {
    length: _propTypes2.default.number.isRequired,
    minRowHeight: _propTypes2.default.number.isRequired,
    height: _propTypes2.default.number,
    preloadBatchSize: _propTypes2.default.number,
    style: _propTypes2.default.shape({
        width: _propTypes2.default.any
    }),
    rowStyle: _propTypes2.default.object,
    rowRender: _propTypes2.default.func.isRequired,
    timeScrollStateLastsForAfterUserScrolls: _propTypes2.default.number
};