"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = binaryIndexSearch;
// Copyright (c) 2014-2017, SeatGeek, Inc.
// All rights reserved.

// Redistribution and use in source and binary forms,
// with or without modification, are permitted provided
// that the following conditions are met:

// Redistributions of source code must retain the above
// copyright notice, this list of conditions and the following disclaimer.

// Neither the name of the SeatGeek nor the names of
// its contributors may be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
// AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


var opts = {
    CLOSEST_LOWER: 1,
    CLOSEST_HIGHER: 2
};

function binaryIndexSearch(array, item, opt) {
    var index = void 0;

    var high = array.length - 1;
    var low = 0;
    var middle = void 0;
    var middleItem = void 0;

    while (low <= high) {
        middle = low + Math.floor((high - low) / 2);
        middleItem = array[middle].offset;

        if (middleItem === item) {
            return middle;
        } else if (middleItem < item) {
            low = middle + 1;
        } else if (middleItem > item) {
            high = middle - 1;
        }
    }

    if (opt === opts.CLOSEST_LOWER && low > 0) {
        index = low - 1;
    } else if (opt === opts.CLOSEST_HIGHER && high < array.length - 1) {
        index = high + 1;
    }

    return index;
}