'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _binaryIndexSearch = require('./binaryIndexSearch');

var _binaryIndexSearch2 = _interopRequireDefault(_binaryIndexSearch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Computer = function () {
    function Computer(minRowHeight, length, height) {
        _classCallCheck(this, Computer);

        this.initRowOffSet(minRowHeight, length);
        this.minRowHeight = minRowHeight;
        this.height = height;
        this.length = length;
    }

    _createClass(Computer, [{
        key: 'initRowOffSet',
        value: function initRowOffSet(minRowHeight, length) {
            this.rowData = [];
            for (var index = 0; index < length; index += 1) {
                this.rowData.push({
                    offset: index * minRowHeight,
                    height: minRowHeight,
                    delayHeight: 0,
                    delayOffset: 0
                });
            }
        }
    }, {
        key: 'cacheRowHeight',
        value: function cacheRowHeight(index, height) {
            this.rowData[index].delayHeight = height - this.rowData[index].height;
            this.rowData[index].height = height;
        }
    }, {
        key: 'updateRowHeightAfterScroll',
        value: function updateRowHeightAfterScroll(beginIndex, endIndex) {
            for (var i = beginIndex; i < this.rowData.length; i += 1) {
                if (i <= endIndex) {
                    if (i === beginIndex) {
                        this.rowData[i].delayOffset = this.rowData[i].delayHeight;
                    } else {
                        this.rowData[i].offset += this.rowData[i - 1].delayOffset;
                        this.rowData[i].delayOffset = this.rowData[i].delayHeight + this.rowData[i - 1].delayOffset;
                    }
                } else if (i > 0 && this.rowData[i - 1].delayOffset === 0) {
                    i = this.rowData.length;
                } else {
                    this.rowData[i].delayOffset = this.rowData[i - 1].delayOffset;
                    this.rowData[i].offset += this.rowData[i].delayOffset;
                }
            }
        }
    }, {
        key: 'getBeginIndex',
        value: function getBeginIndex(scrollTop, preloadBatchSize) {
            var beginIndex = (0, _binaryIndexSearch2.default)(this.rowData, scrollTop, 1) || 0;
            if (beginIndex >= preloadBatchSize) {
                return beginIndex - preloadBatchSize;
            }
            return 0;
        }
    }, {
        key: 'getEndIndex',
        value: function getEndIndex(scrollTop, preloadBatchSize) {
            var endIndex = (0, _binaryIndexSearch2.default)(this.rowData, scrollTop + this.height, 2) || this.length - 1;
            if (endIndex + preloadBatchSize < this.length) {
                return endIndex + preloadBatchSize;
            }
            return this.length - 1;
        }
    }, {
        key: 'getDisplayData',
        value: function getDisplayData(scrollTop, preloadBatchSize, lastBeginIndex, lastBeforeHeight) {
            var beginIndex = this.getBeginIndex(scrollTop, preloadBatchSize);
            var endIndex = this.getEndIndex(scrollTop, preloadBatchSize);

            var beforeHeight = beginIndex === lastBeginIndex ? lastBeforeHeight : this.rowData[beginIndex].offset;
            var afterHeight = this.rowData[this.length - 1].offset - (this.rowData[endIndex].offset - this.rowData[beginIndex].offset) - beforeHeight;
            return {
                beginIndex: beginIndex,
                endIndex: endIndex,
                beforeHeight: beforeHeight,
                afterHeight: afterHeight
            };
        }
    }]);

    return Computer;
}();

exports.default = Computer;